package za.org.treehouse.hypoalarm;

import android.app.Activity;
import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;

import com.triggertrap.seekarc.SeekArc;

// TODO See GlowPad.

// TODO sound audible alarm -- see AlarmKlaxon.java
// TODO Lower alarm volume if in phone call (and detect phone call!)
// TODO Snooze? set another alarm for the next half-hour (or grace_period / 2)?

public class AlarmAlertActivity extends Activity {
    private static Intent notifyIntent;
    public  static Boolean alertFinished, userCancelled;
    public  static Activity alertActivity;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        // Self-reference so we can run finish() from outside.
        alertActivity = this;

        requestWindowFeature(Window.FEATURE_NO_TITLE);
        Window window = getWindow();
        // Set to use the full screen
        int fullScreen = WindowManager.LayoutParams.FLAG_FULLSCREEN;
        if (Build.VERSION.SDK_INT >= 19) {
            fullScreen = WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS;
        }
        window.addFlags(WindowManager.LayoutParams.FLAG_SHOW_WHEN_LOCKED
                | WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON
                | WindowManager.LayoutParams.FLAG_TURN_SCREEN_ON
                | fullScreen
        );
        setContentView(R.layout.alarm_alert);

        notifyIntent = new Intent(getApplicationContext(), AlarmNotify.class);
        // Disable any current notifications (if we're snoozing)
        stopService(notifyIntent);

    }

    @Override
    public void onStart() {
        super.onStart();
        /*
        Button cancelButton = (Button) findViewById(R.id.cancel_dialog_button);
        cancelButton.setOnClickListener (new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                cancelGraceAlarm();
            }
        });
        */
        SeekArc cancelArc = (SeekArc) findViewById(R.id.cancel_dialog_seekArc);
        cancelArc.setOnSeekArcChangeListener(new SeekArc.OnSeekArcChangeListener() {
            volatile Boolean seekFinished = false;
            @Override
            public void onProgressChanged(SeekArc seekArc, int progress, boolean fromUser) {
                if (progress > 98 && !seekFinished && fromUser) {
                    AlarmReceiver.dismissAlarm(alertActivity);
                    seekFinished = true;
                }
            }
            @Override
            public void onStartTrackingTouch(SeekArc seekArc) {
            }
            @Override
            public void onStopTrackingTouch(SeekArc seekArc) {
            }
        });

    }

    /**
     * Handle the user pressing the back/return and home buttons
     */
    @Override
    public void onBackPressed() {
        AlarmReceiver.setAlarmStatus(AlarmReceiver.ALARM_IGNORED);
        AlarmReceiver.snoozeAlarm(this);
    }

    public void onUserLeaveHint() {
        AlarmReceiver.setAlarmStatus(AlarmReceiver.ALARM_IGNORED);
        AlarmReceiver.snoozeAlarm(this);
    }
}